# -*- coding: utf-8 -*-
import sys, re, json
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, urlunparse, urljoin, parse_qs
except ImportError:
    from urllib.parse import urlparse, urlunparse, urljoin, parse_qs
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.93 Safari/537.36'


def httpget(url):
    request = Request(url, headers={'User-Agent': ua})
    try:
        return urlopen(request).read().decode('utf-8')
    except:
        try:
            return urlopen(request).read().decode('gbk')
        except:
            return False


def htmlparser(content):
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(content, 'html.parser')
    return BeautifulSoup(content, 'html5lib')


def category(page=1):
    url = 'https://t66y.com/thread0806.php?fid=22&page=%d' % page
    o = urlparse(url)
    q = parse_qs(o.query)
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    content = httpget(url)
    if not content:
        return {'code': 't66y 100'}
    ret = []
    soup = htmlparser(content)
    for e in soup.select('tr.tr3'):
        e1 = e.select('td.tal')
        if not e1:
            continue
        e1 = e1[0]
        title = e1.text.strip()
        if ord(title[0]) == 8593:
            continue
        e2 = e1.select('h3 a')
        if not e2:
            continue
        e2 = e2[0]
        title = e.select('a.bl')[0].text.strip()
        title += ' ' + e2.text.strip()
        ret.append({'title': title, 'url': urljoin(url, e2['href'])})
    total = soup.select('a#last')
    if total:
        total = total[0]
        total = int(total['href'].split('=')[-1])
        if page < total:
            ret.append({'title': 'Next Page (%d/%d)' % (page + 1, total), 'category': '', 'page': page + 1})
    return ret


def test2(url, purl=None):
    import xbmcgui
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    q = parse_qs(o.query)
    #https://t66y.com/htm_data/2001/22/3772321.html
    #https://baiduyunbo.com/?id=uSIjcjPI
    if o.netloc == 'baiduyunbo.com' and 'id' in q:
        t = 'https://m3u8.cdnpan.com/%s.m3u8' % q['id'][0]
        if not xbmcgui.Dialog().yesno('baiduyunbo', url, t):
            return {'code': ''}
        return {'title': '', 'url': t}
    content = httpget(url)
    if not content:
        return {'code': 't66y 200', 'error': str(url)}
    t = re.search(r'getElementById\(\'iframe1\'\)\.src=\'(.*?)\'', content)
    if t:
        t = t.group(1)
        return test2(t, url)
    # https://t66y.com/htm_data/2001/22/3772567.html
    # https://ppse016.com/play/video.php?id=66
    t = re.search(r'video: \'(.*?)\'', content)
    if t:
        t = t.group(1)
        if not xbmcgui.Dialog().yesno('video: \'\'', purl, url, t):
            return {'code': ''}
        return {'title': '', 'url': t}
    t = re.search(r'iframe src="(.*?)"', content)
    if t:
        t = t.group(1)
        t = re.search(r'url=http(.*)', t)
        if t:
            t = 'http' + t.group(1)
        if not xbmcgui.Dialog().yesno('iframe src=""', purl, url, t):
            return {'code': ''}
        return {'title': '', 'url': t}
    # https://t66y.com/htm_data/2101/22/4300769.html
    # https://yaoshe142.com/embed/26828
    # https://t66y.com/htm_data/2101/22/4300767.html
    # https://ppx237.com/embed/15786
    t = re.search(r'flashvars\s*=\s*(.*?);', content, re.DOTALL)
    if t:
        t = t.group(1)
        video_url = re.search(r'video_url:\s*\'(.*?)\'', t)
        license_code = re.search(r'license_code:\s*\'(.*?)\'', t)
        if not video_url:
            return {'code': 't66y 210', 'error': license_code}
        video_url = video_url.group(1)
        if not license_code:
            if not xbmcgui.Dialog().yesno('flashvars without license', purl, url, video_url):
                return {'code': ''}
        else:
            # https://t66y.com/htm_data/2101/22/4300772.html
            # https://kkembed.kdwshell.com/embed/86519
            license_code = license_code.group(1)
            if len(license_code) != 16:
                return {'code': 't66y 212', 'error': license_code}
            if license_code[0] != '$':
                return {'code': 't66y 213', 'error': license_code}
            license_code = license_code[1:]
            k = int(license_code[:8])
            l = int(license_code[-8:])
            g = k - l
            if g < 0:
                g = -g
            f = str(g * 4)
            i = ''
            for g in range(0, 8):
                for h in range(0, 4):
                    n = int(license_code[g + h]) + int(f[g])
                    if n >= 10:
                        n -= 10
                    i += str(n)
            video_url = video_url.split('/')
            if video_url[0] != 'function':
                return {'code': 't66y 214', 'error': video_url}
            h = video_url[7]
            if len(h) != 32:
                return {'code': 't66y 215', 'error': video_url}
            for k in range(31, -1, -1):
                l = k
                for m in range(k, 32):
                    l += int(i[m])
                l %= len(h)
                n = ''
                for o in range(32):
                    if o == k:
                        n += h[l]
                    elif o == l:
                        n += h[k]
                    else:
                        n += h[o]
                h = n
            video_url[7] = h
            while not video_url[-1] or video_url[-1][0] == '?':
                video_url = video_url[:-1]
            video_url = '/'.join(video_url[2:])
            if not xbmcgui.Dialog().yesno('flashvars with license', purl, url, video_url):
                return {'code': ''}
        return {'title': '', 'url': video_url}
    # https://t66y.com/htm_data/2101/22/4300784.html
    # https://oose026.com/play/video.php?id=5
    # https://t66y.com/htm_data/2101/22/4300615.html
    # https://baiduyunkan.com/embed/21322b748a7c633114a00ad44f7dafdf08b0c?id=1092
    t = re.search(r'DPlayer\((.*?)\);', content, re.DOTALL)
    if t:
        t = t.group(1)
        t1 = re.search(r'url:\s*\'(.*?)\',', t)
        if not t1:
            return {'code': 't66y 220', 'error': url}
        t1 = t1.group(1)
        if not xbmcgui.Dialog().yesno('DPlayer()', purl, url, t1):
            return {'code': ''}
        return {'title': '', 'url': t1.replace('https', 'http')}
    # https://t66y.com/htm_data/2101/22/4300777.html
    # https://www.888dav.com/vod/168516/
    t = re.search(r'player_data={(.*?)}', content, re.DOTALL)
    if t:
        t = '{' + t.group(1) + '}'
        data = json.loads(t)
        if not xbmcgui.Dialog().yesno('player_data={}', purl, url, data['url']):
            return {'code': ''}
        return {'title': '', 'url': data['url']}
    # https://t66y.com/htm_data/2101/22/4300714.html
    # http://91.9p9.xyz/ev.php?VID=1a17DB38YziY2J0ir6fNYtYPGLmaeLsDw2tnPzZrWoNNRJo48pQTAQ
    t = re.search(r'strencode\((.*?)\);', content)
    if t:
        xbmcgui.Dialog().ok('strencode()', purl, url)
        t = '(' + t.group(1) + ')'
        return {'code': 't66y 230', 'error': url}
    return {'code': 't66y 201'}
